#pragma once

#include <string>
#include <sstream>

class PngInfo
{
public:
    enum class ColorType : unsigned char
    {
        GREYSCALE = 0,
        RGB = 2,
        PALETTE = 3,
        GREYSCALE_ALPHA = 4,
        RGB_ALPHA = 6,
    };

    std::string toString(ColorType colorType) const
    {
        switch(colorType)
        {
            case ColorType::GREYSCALE:
                return "GREYSCALE";
            case ColorType::RGB:
                return "RGB";
            case ColorType::PALETTE:
                return "PALETTE";
            case ColorType::GREYSCALE_ALPHA:
                return "GREYSCALE_ALPHA";
            case ColorType::RGB_ALPHA:
                return "RGB_ALPHA";
            default:
                return "UNKNOWN";
        }
    }

    std::string toString() const
    {
        std::stringstream sstr;
        sstr << "PngInfo" << "\n";
        sstr << "colorType: " << toString(mColorType) << "\n";
        sstr << "compressionMethod: " << (int)mCompressionMethod << "\n";
        sstr << "filterMethod: " << (int)mFilterMethod << "\n";
        sstr << "interlaceMethod: " << (int)mInterlaceMethod << "\n";
        return sstr.str();
    }

    ColorType mColorType{ColorType::RGB};
    unsigned char mCompressionMethod{0};
    unsigned char mFilterMethod{0};
    unsigned char mInterlaceMethod{0};
};




